/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.28 from the
 * contents of Apache.xs. Do not edit this file, edit Apache.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

/* ====================================================================
 * The Apache Software License, Version 1.1
 *
 * Copyright (c) 1996-2000 The Apache Software Foundation.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "Apache" and "Apache Software Foundation" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *    nor may "Apache" appear in their name, without prior written
 *    permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 */

#define CORE_PRIVATE
#include "mod_perl.h"
#include "mod_perl_xs.h"


#ifdef USE_SFIO
#undef send_fd_length    
static long send_fd_length(FILE *f, request_rec *r, long length)
{
    croak("Apache::send_fd() not supported with sfio");
    return 0;
}
#endif

#if defined(PERL_STACKED_HANDLERS) && defined(PERL_GET_SET_HANDLERS)

#define PER_DIR_CONFIG 1
#define PER_SRV_CONFIG 2

typedef struct {
    int type;
    char *name;
    void *offset;
    void (*set_func) (void *, void *, SV *);
} perl_handler_table;

typedef struct {
    I32 fill;
    AV *av;
    AV **ptr;
} perl_save_av;

static void set_handler_dir (perl_handler_table *tab, request_rec *r, SV *sv);
static void set_handler_srv (perl_handler_table *tab, request_rec *r, SV *sv);

#define HandlerDirEntry(name,member) \
PER_DIR_CONFIG, name, (void*)XtOffsetOf(perl_dir_config,member), \
(void(*)(void *, void *, SV *)) set_handler_dir

#define HandlerSrvEntry(name,member) \
PER_SRV_CONFIG, name, (void*)XtOffsetOf(perl_server_config,member), \
(void(*)(void *, void *, SV *)) set_handler_srv

static perl_handler_table handler_table[] = {
    {HandlerSrvEntry("PerlPostReadRequestHandler", PerlPostReadRequestHandler)},
    {HandlerSrvEntry("PerlTransHandler", PerlTransHandler)},
    {HandlerDirEntry("PerlHeaderParserHandler", PerlHeaderParserHandler)},
    {HandlerDirEntry("PerlAccessHandler", PerlAccessHandler)},
    {HandlerDirEntry("PerlAuthenHandler", PerlAuthenHandler)},
    {HandlerDirEntry("PerlAuthzHandler", PerlAuthzHandler)},
    {HandlerDirEntry("PerlTypeHandler", PerlTypeHandler)},
    {HandlerDirEntry("PerlFixupHandler", PerlFixupHandler)},
    {HandlerDirEntry("PerlHandler", PerlHandler)},
    {HandlerDirEntry("PerlLogHandler", PerlLogHandler)},
    {HandlerDirEntry("PerlCleanupHandler", PerlCleanupHandler)},
    { FALSE, NULL }
};

static void perl_restore_av(void *data)
{
    perl_save_av *save_av = (perl_save_av *)data;

    if(save_av->fill != DONE) {
	AvFILLp(*save_av->ptr) = save_av->fill;
    }
    else if(save_av->av != Nullav) {
	*save_av->ptr = save_av->av;
    }
}

static void perl_handler_merge_avs(char *hook, AV **dest)
{
    int i = 0;
    HV *hv = perl_get_hv("Apache::PerlStackedHandlers", FALSE);
    SV **svp = hv_fetch(hv, hook, strlen(hook), FALSE);
    AV *base;
    
    if(!(svp && SvROK(*svp)))
	return;

    base = (AV*)SvRV(*svp);
    for(i=0; i<=AvFILL(base); i++) { 
	SV *sv = *av_fetch(base, i, FALSE);
	av_push(*dest, SvREFCNT_inc(sv));
    }
}

static void set_handler_base(void *ptr, perl_handler_table *tab, pool *p, SV *sv) 
{
    AV **av = (AV **)((char *)ptr + (int)(long)tab->offset);

    perl_save_av *save_av = 
	(perl_save_av *)palloc(p, sizeof(perl_save_av));

    save_av->fill = DONE;
    save_av->av = Nullav;
    
    if((sv == &sv_undef) || (SvIOK(sv) && SvIV(sv) == DONE)) {
	if(AvTRUE(*av)) {
	    save_av->fill = AvFILL(*av);
	    AvFILLp(*av) = -1;
	}
    }
    else if(SvROK(sv) && SvTYPE(SvRV(sv)) == SVt_PVAV) {
	if(AvTRUE(*av))
	    save_av->av = av_copy_array(*av);
	*av = (AV*)SvRV(sv);
	++SvREFCNT(*av);
    }
    else {
	croak("Can't set_handler with that value");
    }
    save_av->ptr = av;
    register_cleanup(p, save_av, perl_restore_av, mod_perl_noop);
}

static void set_handler_dir(perl_handler_table *tab, request_rec *r, SV *sv)
{
    dPPDIR; 
    set_handler_base((void*)cld, tab, r->pool, sv);
}

static void set_handler_srv(perl_handler_table *tab, request_rec *r, SV *sv)
{
    dPSRV(r->server); 
    set_handler_base((void*)cls, tab, r->pool, sv);
}

static perl_handler_table *perl_handler_lookup(char *name)
{
    int i;
    for (i=0; handler_table[i].name; i++) {
	perl_handler_table *tab = &handler_table[i];
        if(strEQ(name, tab->name))
	    return tab;
    }
    return NULL;
}


static SV *get_handlers(request_rec *r, char *hook)
{
    AV *avcopy;
    AV **av;
    dPPDIR;
    dPSRV(r->server);
    void *ptr;
    perl_handler_table *tab = perl_handler_lookup(hook);

    if(!tab) return Nullsv;

    if(tab->type == PER_DIR_CONFIG)
	ptr = (void*)cld;
    else
	ptr = (void*)cls;

    av = (AV **)((char *)ptr + (int)(long)tab->offset);

    if(*av) 
	avcopy = av_copy_array(*av);
    else
	avcopy = newAV();

    perl_handler_merge_avs(hook, &avcopy);

    return newRV_noinc((SV*)avcopy);
}

static void set_handlers(request_rec *r, SV *hook, SV *sv)
{
    dTHR;
    perl_handler_table *tab = perl_handler_lookup(SvPV(hook,na));
    if(tab && tab->set_func) 
        (*tab->set_func)(tab, r, sv);

    (void)hv_delete_ent(perl_get_hv("Apache::PerlStackedHandlers", FALSE),
			hook, G_DISCARD, FALSE);
}
#endif

#if MODULE_MAGIC_NUMBER < 19970909
static void
child_terminate(request_rec *r)
{
#ifndef WIN32
    log_transaction(r);
#endif
    exit(0);
}
#endif

static char *custom_response(request_rec *r, int status, char *string, int reset)
{
    core_dir_config *conf = (core_dir_config *)
	get_module_config(r->per_dir_config, &core_module);
    int idx;
    char *retval = NULL;

    if(conf->response_code_strings == NULL) {
        conf->response_code_strings = (char **)
	  pcalloc(perl_get_startup_pool(),
		  sizeof(*conf->response_code_strings) * 
		  RESPONSE_CODES);
    }

    idx = index_of_response(status);
    retval = conf->response_code_strings[idx];
    if (reset) {
        conf->response_code_strings[idx] = NULL;
    }
    else if (string) {
	conf->response_code_strings[idx] = 
	    ((is_url(string) || (*string == '/')) && (*string != '"')) ? 
		pstrdup(r->pool, string) : pstrcat(r->pool, "\"", string, NULL);
    }

    return retval;
}

static void Apache_terminate_if_done(request_rec *r, int sts)
{
#ifndef WIN32
    if(Apache_exit_is_done(sts)) child_terminate(r);
#endif
}

#if MODULE_MAGIC_NUMBER < 19980317
int basic_http_header(request_rec *r);
#endif

#if MODULE_MAGIC_NUMBER < 19980201
unsigned get_server_port(const request_rec *r)
{
    unsigned port = r->server->port ? r->server->port : 80;

    return r->hostname ? ntohs(r->connection->local_addr.sin_port)
	: port;
}
#define get_server_name(r) \
    (r->hostname ? r->hostname : r->server->server_hostname) 
#endif

#if MODULE_MAGIC_AT_LEAST(19981108, 1)
#define mod_perl_define(sv,name) ap_exists_config_define(name)
#elif(MODULE_MAGIC_NUMBER >= MMN_131) && !defined(WIN32)
static int mod_perl_define(SV *sv, char *name)
{
    char **defines;
    int i;

    defines = (char **)ap_server_config_defines->elts;
    for (i = 0; i < ap_server_config_defines->nelts; i++) {
        if (strcmp(defines[i], name) == 0) {
            return 1;
        }
    }
    return 0;
}
#else
#define mod_perl_define(sv,name) 0
#endif

static int sv_str_header(void *arg, const char *k, const char *v)
{
    SV *sv = (SV*)arg;
    sv_catpvf(sv, "%s: %s\n", k, v);
    return 1;
}

#if MODULE_MAGIC_NUMBER >= 19980806
/*
 * ap_scan_script_header_err_core(r, buffer, getsfunc_SV, sv)
 */
#if 0
static int getsfunc_SV(char *buf, int bufsiz, void *param)
{
    SV *sv = (SV*)param;
    STRLEN len;
    char *tmp = SvPV(sv,len);
    int i;

    if(!SvTRUE(sv)) 
	return 0;

    for(i=0; i<=len; i++) {
	if(tmp[i] == LF) break;
    }

    Move(tmp, buf, i, char);
    buf[i] = '\0';

    if(len < i) {
	sv_setpv(sv, "");
    }
    else {
	tmp += i+1;
	sv_setpv(sv, tmp);
    }
    return 1;
}
#endif /*0*/
#endif /*MODULE_MAGIC_NUMBER*/

static void rwrite_neg_trace(request_rec *r)
{
#if HAS_MMN_130
    ap_log_error(APLOG_MARK, APLOG_DEBUG, r->server,
#else
    fprintf(stderr,
#endif
		 "mod_perl: rwrite returned -1 (fd=%d, B_EOUT=%d)\n",
		 ap_bfileno(r->connection->client, B_WR), 
		 r->connection->client->flags & B_EOUT);
}

#define check_auth_type(r) \
    if (!auth_type(r)) { \
        (void)mod_perl_auth_type(r, "Basic"); \
    }

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif


XS_EUPXS(XS_Apache_add_version_component); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_add_version_component)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "name");
    {
	const char *	name = (const char *)SvPV_nolen(ST(0))
;
    ap_add_version_component(name);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Apache_current_callback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_current_callback)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;
	const char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    RETVAL = PERL_GET_CUR_HOOK;

	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_sent_header); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_sent_header)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "r, val=0");
    {
	Apache	r;
	int	val;
	int	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	if (items < 2)
	    val = 0;
	else {
	    val = (int)SvIV(ST(1))
;
	}

	RETVAL = mod_perl_sent_header(r, val);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_seqno); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_seqno)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, inc=0");
    {
	SV *	self = ST(0)
;
	int	inc;
	int	RETVAL;
	dXSTARG;

	if (items < 2)
	    inc = 0;
	else {
	    inc = (int)SvIV(ST(1))
;
	}

	RETVAL = mod_perl_seqno(self, inc);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_perl_hook); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_perl_hook)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "name");
    {
	char *	name = (char *)SvPV_nolen(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = perl_hook(name);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#if defined(PERL_GET_SET_HANDLERS)
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_Apache_get_handlers); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_get_handlers)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "r, hook");
    {
	Apache	r;
	char *	hook = (char *)SvPV_nolen(ST(1))
;
	SV *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv)
;
#ifdef get_handlers
    get_handlers(r,hook);
#else
    RETVAL = get_handlers(r,hook);
#endif

	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_set_handlers); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_set_handlers)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "r, hook, sv");
    {
	Apache	r;
	SV *	hook = ST(1)
;
	SV *	sv = ST(2)
;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	set_handlers(r, hook, sv);
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_Apache_push_handlers); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_push_handlers)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, hook, cv");
    {
	SV *	self = ST(0)
;
	char *	hook = (char *)SvPV_nolen(ST(1))
;
	SV *	cv = ST(2)
;
	int	RETVAL;
	dXSTARG;
    RETVAL = mod_perl_push_handlers(self, hook, cv, Nullav);

	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_can_stack_handlers); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_can_stack_handlers)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	int	RETVAL;
	dXSTARG;

	RETVAL = mod_perl_can_stack_handlers(self);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_register_cleanup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_register_cleanup)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "r, sv");
    {
	Apache	r;
	SV *	sv = ST(1)
;
    ix = ix; /* avoid -Wall warning */

	r = sv2request_rec(ST(0), "Apache", cv)
;

	mod_perl_register_cleanup(r, sv);
    }
    XSRETURN_EMPTY;
}

#define APACHE_REGISTRY_CURSTASH perl_get_sv("Apache::Registry::curstash", TRUE)

XS_EUPXS(XS_Apache_clear_rgy_endav); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_clear_rgy_endav)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "r, sv=APACHE_REGISTRY_CURSTASH");
    {
	Apache	r;
	SV *	sv;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	if (items < 2)
	    sv = APACHE_REGISTRY_CURSTASH;
	else {
	    sv = ST(1)
;
	}

	mod_perl_clear_rgy_endav(r, sv);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Apache_stash_rgy_endav); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_stash_rgy_endav)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "r, sv=APACHE_REGISTRY_CURSTASH");
    {
	Apache	r;
	SV *	sv;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	if (items < 2)
	    sv = APACHE_REGISTRY_CURSTASH;
	else {
	    sv = ST(1)
;
	}
    perl_stash_rgy_endav(r->uri, sv);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Apache_define); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_define)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv, name");
    {
	SV *	sv = ST(0)
;
	char *	name = (char *)SvPV_nolen(ST(1))
;
	I32	RETVAL;
	dXSTARG;

	RETVAL = mod_perl_define(sv, name);
	XSprePUSH; PUSHi((IV)RETVAL);
    sv = sv; /*-Wall*/
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_module); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_module)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv, name");
    {
	SV *	sv = ST(0)
;
	SV *	name = ST(1)
;
	I32	RETVAL;
	dXSTARG;
    if((*(SvEND(name) - 2) == '.') && (*(SvEND(name) - 1) == 'c'))
        RETVAL = find_linked_module(SvPVX(name)) ? 1 : 0;
    else
        RETVAL = (sv && perl_module_is_loaded(SvPVX(name)));

	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_set_opmask); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_set_opmask)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "r, sv");
    {
	Apache	r;
	SV *	sv = ST(1)
;
	char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	RETVAL = mod_perl_set_opmask(r, sv);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_untaint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_untaint)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    {
    int i;

    if(!tainting) XSRETURN_EMPTY;
    for(i=1; i<items; i++) 
        mod_perl_untaint(ST(i));
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Apache_taint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_taint)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    {
    int i;

    if(!tainting) XSRETURN_EMPTY;
    for(i=1; i<items; i++)
        sv_magic(ST(i), Nullsv, 't', Nullch, 0);
    }
    XSRETURN_EMPTY;
}

#ifndef WIN32
#define XSubPPtmpAAAB 1


XS_EUPXS(XS_Apache_child_terminate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_child_terminate)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	child_terminate(r);
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_Apache_exit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_exit)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    {
    int sts = 0;
    request_rec *r = NULL;

    /* $r->exit */
    r = sv2request_rec(ST(0), "Apache", cv);

    if(items > 1) {
        sts = (int)SvIV(ST(1));
    }
    else { /* Apache::exit() */
	if(SvTRUE(ST(0)) && SvIOK(ST(0)))
	    sts = (int)SvIV(ST(0));
    }

    MP_CHECK_REQ(r, "Apache::exit");

    if(!r->connection->aborted)
        rflush(r);
    Apache_terminate_if_done(r,sts);
    perl_call_halt(sts);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_CLOSE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_CLOSE)
{
    dVAR; dXSARGS;
    dXSI32;
    PERL_UNUSED_VAR(cv); /* -W */
    {
    items = items;
    ix = ix;
    /*NOOP*/
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Apache_TIEHANDLE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_TIEHANDLE)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "classname, r=NULL");
    {
	SV *	classname = ST(0)
;
	Apache	r;
	Apache	RETVAL;

	if (items < 2)
	    r = NULL;
	else {
	    r = sv2request_rec(ST(1), "Apache", cv)
;
	}
    RETVAL = (r && classname) ? r : perl_request_rec(NULL);

	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Apache", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_OPEN); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_OPEN)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, arg1, arg2=Nullsv");
    {
	SV *	self = ST(0)
;
	SV *	arg1 = ST(1)
;
	SV *	arg2;
    char *name;
    STRLEN len;
    GV *gv = gv_fetchpv("STDOUT", TRUE, SVt_PVIO);
    SV *arg;

	int	RETVAL;
	dXSTARG;

	if (items < 3)
	    arg2 = Nullsv;
	else {
	    arg2 = ST(2)
;
	}
    sv_unmagic((SV*)gv, 'q'); /* untie *STDOUT */
    if (arg2 && self) {
        arg = newSVsv(arg1);
        sv_catsv(arg, arg2);
    }
    else {
        arg = arg1;
    }

    name = SvPV(arg, len);
    RETVAL = do_open(gv, name, len, FALSE, O_RDONLY, 0, Nullfp);

	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_FILENO); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_FILENO)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;
	int	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    RETVAL = fileno(stdout);

	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_as_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_as_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;
	SV *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    RETVAL = newSVpv(r->the_request,0);
    sv_catpvn(RETVAL, "\n", 1);

    table_do(sv_str_header, (void*)RETVAL, r->headers_in, NULL);
    sv_catpvf(RETVAL, "\n%s %s\n", r->protocol, r->status_line);

    table_do(sv_str_header, (void*)RETVAL, r->headers_out, NULL);
    table_do(sv_str_header, (void*)RETVAL, r->err_headers_out, NULL);
    sv_catpvn(RETVAL, "\n", 1);

	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_chdir_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_chdir_file)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "r, file=r->filename");
    {
	Apache	r;
	const char *	file;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	if (items < 2)
	    file = r->filename;
	else {
	    file = (const char *)SvPV_nolen(ST(1))
;
	}
    chdir_file(file);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Apache_gensym); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_gensym)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "pack=\"Apache::Symbol\"");
    {
	char *	pack;
	SV *	RETVAL;

	if (items < 1)
	    pack = "Apache::Symbol";
	else {
	    pack = (char *)SvPV_nolen(ST(0))
;
	}

	RETVAL = mod_perl_gensym(pack);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_slurp_filename); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_slurp_filename)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;
	SV *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	RETVAL = mod_perl_slurp_filename(r);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_unescape_url); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_unescape_url)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	char *	RETVAL;
	dXSTARG;
    char *string = SvPV_force(sv, PL_na);

    unescape_url(string);
    RETVAL = string;

	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_unescape_url_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_unescape_url_info)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "url");
    {
	char *	url = (char *)SvPV_nolen(ST(0))
;
	char *	RETVAL;
	dXSTARG;
    register char * trans = url ;
    char digit ;

    if (!url || !*url) {
        XSRETURN_UNDEF;
    }

    RETVAL = url;

    while (*url != '\0') {
        if (*url == '+')
            *trans = ' ';
	else if (*url != '%')
	    *trans = *url;
        else if (!isxdigit(url[1]) || !isxdigit(url[2]))
            *trans = '%';
        else {
            url++ ;
            digit = ((*url >= 'A') ? ((*url & 0xdf) - 'A')+10 : (*url - '0'));
            url++ ;
            *trans = (digit << 4) +
		(*url >= 'A' ? ((*url & 0xdf) - 'A')+10 : (*url - '0'));
        }
        url++, trans++ ;
    }
    *trans = '\0';

	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_hard_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_hard_timeout)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "r, string");
    {
	Apache	r;
	char *	string = (char *)SvPV_nolen(ST(1))
;

	r = sv2request_rec(ST(0), "Apache", cv)
;
#ifndef USE_THREADS
    hard_timeout(string, r);
#endif
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Apache_soft_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_soft_timeout)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "r, string");
    {
	Apache	r;
	char *	string = (char *)SvPV_nolen(ST(1))
;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    soft_timeout(string, r);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Apache_kill_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_kill_timeout)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;

	r = sv2request_rec(ST(0), "Apache", cv)
;
#ifndef USE_THREADS
    kill_timeout(r);
#endif
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Apache_reset_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_reset_timeout)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	reset_timeout(r);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Apache_translate_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_translate_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;
	int	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
#ifdef WIN32
    croak("Apache->translate_name not supported under Win32");
    RETVAL = DECLINED;
#else
    RETVAL = translate_name(r);
#endif

	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_custom_response); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_custom_response)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "r, status, string=NULL");
    {
	Apache	r;
	int	status = (int)SvIV(ST(1))
;
	char *	string;
	char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	if (items < 3)
	    string = NULL;
	else {
	    string = (char *)SvPV_nolen(ST(2))
;
	}
    RETVAL = custom_response(r, status, string, ST(2) == &sv_undef);

	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_satisfies); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_satisfies)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;
	int	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	RETVAL = satisfies(r);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_some_auth_required); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_some_auth_required)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;
	int	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	RETVAL = some_auth_required(r);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_requires); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_requires)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;
    AV *av;
    HV *hv;
    register int x;
    int m;
    char *t;
    MP_CONST_ARRAY_HEADER *reqs_arr;
    require_line *reqs;


	r = sv2request_rec(ST(0), "Apache", cv)
;
    m = r->method_number;
    reqs_arr = requires (r);

    if (!reqs_arr)
	ST(0) = &sv_undef;
    else {
	reqs = (require_line *)reqs_arr->elts;
	iniAV(av);
        for(x=0; x < reqs_arr->nelts; x++) {
	    /* XXX should we do this or let PerlAuthzHandler? */
	    if (! (reqs[x].method_mask & (1 << m))) continue;
	    t = reqs[x].requirement;
	    iniHV(hv);
	    hv_store(hv, "method_mask", 11, 
		     newSViv((IV)reqs[x].method_mask), 0);
	    hv_store(hv, "requirement", 11, 
		     newSVpv(reqs[x].requirement,0), 0);
	    av_push(av, newRV((SV*)hv));
	}
	ST(0) = newRV_noinc((SV*)av); 
    }
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_allow_options); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_allow_options)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;
	int	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	RETVAL = allow_options(r);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_get_server_port); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_get_server_port)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;
	unsigned	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	RETVAL = get_server_port(r);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_get_server_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_get_server_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;
	const char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	RETVAL = get_server_name(r);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_get_remote_host); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_get_remote_host)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "r, type=REMOTE_NAME");
    {
	Apache	r;
	int	type;
	char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	if (items < 2)
	    type = REMOTE_NAME;
	else {
	    type = (int)SvIV(ST(1))
;
	}
    RETVAL = (char *)get_remote_host(r->connection, 
				     r->per_dir_config, type);

	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_get_remote_logname); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_get_remote_logname)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;
	const char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	RETVAL = get_remote_logname(r);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_auth_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_auth_name)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "r, val=NULL");
    {
	Apache	r;
	char *	val;
	char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	if (items < 2)
	    val = NULL;
	else {
	    val = (char *)SvPV_nolen(ST(1))
;
	}

	RETVAL = mod_perl_auth_name(r, val);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_auth_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_auth_type)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "r, val=NULL");
    {
	Apache	r;
	char *	val;
	const char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	if (items < 2)
	    val = NULL;
	else {
	    val = (char *)SvPV_nolen(ST(1))
;
	}

	RETVAL = mod_perl_auth_type(r, val);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_document_root); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_document_root)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "r, ...");
    {
	Apache	r;
    core_server_config *conf;

	const char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    conf = (core_server_config *)
      get_module_config(r->server->module_config, &core_module);

    RETVAL = conf->ap_document_root;

    if (items > 1) {
        SV *doc_root = perl_get_sv("Apache::Server::DocumentRoot", TRUE);
        sv_setsv(doc_root, ST(1));
        conf->ap_document_root = SvPVX(doc_root);
    }

	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_server_root_relative); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_server_root_relative)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "rsv, name=\"\"");
    {
	SV *	rsv = ST(0)
;
	char *	name;
    pool *p;
    request_rec *r;

	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    name = "";
	else {
	    name = (char *)SvPV_nolen(ST(1))
;
	}
    if (SvROK(rsv) && (r = sv2request_rec(rsv, "Apache", cv))) {
	p = r->pool;
    }
    else {
	if(!(p = perl_get_startup_pool()))
	   croak("Apache::server_root_relative: no startup pool available");
    }

    RETVAL = (char *)server_root_relative(p, name);

	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_note_basic_auth_failure); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_note_basic_auth_failure)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    check_auth_type(r);
    note_basic_auth_failure(r);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Apache_get_basic_auth_pw); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_get_basic_auth_pw)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Apache	r;
    MP_CONST_CHAR *sent_pw = NULL;
    int ret;


	r = sv2request_rec(ST(0), "Apache", cv)
;
    check_auth_type(r);
    ret = get_basic_auth_pw(r, &sent_pw);
    XPUSHs(sv_2mortal((SV*)newSViv(ret)));
    if(ret == OK)
	XPUSHs(sv_2mortal((SV*)newSVpv((char *)sent_pw, 0)));
    else
	XPUSHs(&sv_undef);
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Apache_user); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_user)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "r, ...");
    {
	Apache	r;
	char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    get_set_PVp(r->connection->user,r->pool);

	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_basic_http_header); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_basic_http_header)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;

	r = sv2request_rec(ST(0), "Apache", cv)
;
#ifdef WIN32
    croak("Apache->basic_http_header() not supported under Win32!");
#else
    basic_http_header(r);
#endif
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Apache_send_http_header); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_send_http_header)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "r, type=NULL");
    {
	Apache	r;
	char *	type;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	if (items < 2)
	    type = NULL;
	else {
	    type = (char *)SvPV_nolen(ST(1))
;
	}
    if(type)
        r->content_type = pstrdup(r->pool, type);
    send_http_header(r);
    mod_perl_sent_header(r, 1);
    }
    XSRETURN_EMPTY;
}

#ifndef PERL_OBJECT
#define XSubPPtmpAAAC 1


XS_EUPXS(XS_Apache_send_fd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_send_fd)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "r, f, length=-1");
    {
	Apache	r;
	FILE *	f = PerlIO_findFILE(IoIFP(sv_2io(ST(1))))
;
	long	length;
	int	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	if (items < 3)
	    length = -1;
	else {
	    length = (long)SvIV(ST(2))
;
	}
    if (!f) {
        croak("send_fd: NULL filehandle "
              "(hint: did you check the return value of open?)");
    }
    RETVAL = send_fd_length(f, r, length);

	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_Apache_rflush); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_rflush)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;
	int	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	RETVAL = rflush(r);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_read_client_block); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_read_client_block)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "r, buffer, bufsiz");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Apache	r;
	SV *	buffer = ST(1)
;
	STRLEN	bufsiz = (STRLEN)SvUV(ST(2))
;
    long nrd = 0, old_read_length;
    int rc;


	r = sv2request_rec(ST(0), "Apache", cv)
;
    if (!r->read_length) {
        if ((rc = setup_client_block(r, REQUEST_CHUNKED_ERROR)) != OK) {
            aplog_error(APLOG_MARK, APLOG_ERR | APLOG_NOERRNO, r->server, 
                        "mod_perl: setup_client_block failed: %d", rc);
            XSRETURN_UNDEF;
        }
    }

    old_read_length = r->read_length;
    r->read_length = 0;

    if (should_client_block(r)) {
        (void)SvUPGRADE(buffer, SVt_PV);
        SvGROW(buffer, bufsiz+1);
        nrd = get_client_block(r, SvPVX(buffer), bufsiz);
    }
    r->read_length += old_read_length;

    if (nrd > 0) {
        XPUSHs(sv_2mortal(newSViv((long)nrd)));
#ifdef PERL_STASH_POST_DATA
        table_set(r->subprocess_env, "POST_DATA", SvPVX(buffer));
#endif
        SvCUR_set(buffer, nrd);
        *SvEND(buffer) = '\0';
        SvPOK_only(buffer);
        SvTAINTED_on(buffer);
    } 
    else {
        sv_setsv(buffer, &sv_undef);
    }
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Apache_setup_client_block); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_setup_client_block)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "r, policy=REQUEST_CHUNKED_ERROR");
    {
	Apache	r;
	int	policy;
	int	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	if (items < 2)
	    policy = REQUEST_CHUNKED_ERROR;
	else {
	    policy = (int)SvIV(ST(1))
;
	}

	RETVAL = setup_client_block(r, policy);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_should_client_block); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_should_client_block)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;
	int	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	RETVAL = should_client_block(r);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_get_client_block); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_get_client_block)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "r, buffer, bufsiz");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Apache	r;
	SV *	buffer = ST(1)
;
	STRLEN	bufsiz = (STRLEN)SvUV(ST(2))
;
    long nrd = 0;


	r = sv2request_rec(ST(0), "Apache", cv)
;
    (void)SvUPGRADE(buffer, SVt_PV);
    SvGROW(buffer, bufsiz+1);
    nrd = get_client_block(r, SvPVX(buffer), bufsiz);
    if ( nrd > 0 ) {
        XPUSHs(sv_2mortal(newSViv((long)nrd)));
        SvCUR_set(buffer, nrd);
        *SvEND(buffer) = '\0';
        SvPOK_only(buffer);
        SvTAINTED_on(buffer);
    } 
    else {
	sv_setsv(ST(1), &sv_undef);
    }
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Apache_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_write)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "r, sv_buffer, sv_length=-1, offset=0");
    {
	Apache	r;
	SV *	sv_buffer = ST(1)
;
	int	sv_length;
	int	offset;
    STRLEN len;
    char *buffer;
    int sent = 0;

	int	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	if (items < 3)
	    sv_length = -1;
	else {
	    sv_length = (int)SvIV(ST(2))
;
	}

	if (items < 4)
	    offset = 0;
	else {
	    offset = (int)SvIV(ST(3))
;
	}
    ix = ix; /* avoid -Wall warning */
    RETVAL = 0;

    if (r->connection->aborted) {
        XSRETURN_UNDEF;
    }

    buffer = SvPV(sv_buffer, len);
    if (sv_length != -1) {
        len = sv_length;
    }

    if (offset) {
        buffer += offset;
    }

    while (len > 0) {
        sent = rwrite(buffer,
                      len < HUGE_STRING_LEN ? len : HUGE_STRING_LEN,
                      r);
        if (sent < 0) {
            rwrite_neg_trace(r);
	    break;
        }
        buffer += sent;
        len -= sent;
        RETVAL += sent;
    }

	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_print); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_print)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "r, ...");
    {
	Apache	r;
	int	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    ix = ix; /* avoid -Wall warning */

    if(!mod_perl_sent_header(r, 0)) {
	SV *sv = sv_newmortal();
	SV *rp = ST(0);
	SV *sendh = perl_get_sv("Apache::__SendHeader", TRUE);

	if(items > 2)
	    do_join(sv, &sv_no, MARK+1, SP); /* $sv = join '', @_[1..$#_] */
        else
	    sv_setsv(sv, ST(1));

	PUSHMARK(sp);
	XPUSHs(rp);
	XPUSHs(sv);
	PUTBACK;
	sv_setiv(sendh, 1);
	perl_call_pv("Apache::send_cgi_header", G_SCALAR);
	sv_setiv(sendh, 0);
    }
    else {
        /* should exist already */
        CV *cv = GvCV(gv_fetchpv("Apache::write_client", GV_ADDWARN, SVt_PVCV));
	soft_timeout("mod_perl: Apache->print", r);
	PUSHMARK(mark);
#ifdef PERL_OBJECT
	(void)(*CvXSUB(cv))(cv, pPerl); /* &Apache::write_client; */
#else
	(void)(*CvXSUB(cv))(aTHXo_ cv); /* &Apache::write_client; */
#endif

	if(IoFLAGS(GvIOp(defoutgv)) & IOf_FLUSH) /* if $| != 0; */
#if MODULE_MAGIC_NUMBER >= 19970103
	    rflush(r);
#else
	    bflush(r->connection->client);
#endif
	kill_timeout(r);
    }

    RETVAL = !r->connection->aborted;

	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_write_client); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_write_client)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "r, ...");
    {
	Apache	r;
    int i;
    char * buffer;
    STRLEN len;

	int	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    RETVAL = 0;

    if (r->connection->aborted)
        XSRETURN_IV(0);

    for(i = 1; i <= items - 1; i++) {
	int sent = 0;
        SV *sv = SvROK(ST(i)) && (SvTYPE(SvRV(ST(i))) == SVt_PV) ?
                 (SV*)SvRV(ST(i)) : ST(i);
	buffer = SvPV(sv, len);
#ifdef APACHE_SSL
        while(len > 0) {
	    sent = rwrite(buffer,
	        	  len < HUGE_STRING_LEN ? len : HUGE_STRING_LEN,
	        	  r);
	    if(sent < 0) {
		rwrite_neg_trace(r);
		/* break out of outer loop too */
		i = items;
		break;
	    }
	    buffer += sent;
	    len -= sent;
	    RETVAL += sent;
        }
#else
        if((sent = rwrite(buffer, len, r)) < 0) {
	    rwrite_neg_trace(r);
	    break;
        }
        RETVAL += sent;
#endif
    }

	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_internal_redirect_handler); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_internal_redirect_handler)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "r, location");
    {
	Apache	r;
	char *	location = (char *)SvPV_nolen(ST(1))
;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    switch((ix = XSANY.any_i32)) {
	case 0:
	internal_redirect_handler(location, r);
	break;
	case 1:
	internal_redirect(location, r);
	break;
    }
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Apache_log_reason); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_log_reason)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "r, reason, filename=NULL");
    {
	Apache	r;
	char *	reason = (char *)SvPV_nolen(ST(1))
;
	char *	filename;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	if (items < 3)
	    filename = NULL;
	else {
	    filename = (char *)SvPV_nolen(ST(2))
;
	}
    if(filename == NULL)
        filename = r->uri; 
    mod_perl_log_reason(reason, filename, r);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Apache_log_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_log_error)
{
    dVAR; dXSARGS;
    dXSI32;
    PERL_UNUSED_VAR(cv); /* -W */
    {
    server_rec *s = NULL;
    request_rec *r = NULL;
    int i=0;
    char *errstr = NULL;
    SV *sv = Nullsv;

    if((items > 1) && (r = sv2request_rec(ST(0), "Apache", cv))) {
	s = r->server;
	i=1;
    }
    else if((items > 1) && sv_derived_from(ST(0), "Apache::Server")) {
	IV tmp = SvIV((SV*)SvRV(ST(0)));
	s = (Apache__Server )tmp;
	i=1;	

	/* if below is true, delay log_error */
	if(PERL_RUNNING() < PERL_DONE_STARTUP) {
	    MP_TRACE_g(fprintf(stderr, "error_log not open yet\n"));
	    XSRETURN_UNDEF;
	}
    }
    else { 
	if(r) 
	    s = r->server;
	else
	    s = perl_get_startup_server();
    }

    if(!s) croak("Apache::warn: no server_rec!");

    if(items > 1+i) {
	sv = newSV(0);
        do_join(sv, &sv_no, MARK+i, SP); /* $sv = join '', @_[1..$#_] */
        errstr = SvPV(sv,na);
    }
    else
        errstr = SvPV(ST(i),na);

    switch((ix = XSANY.any_i32)) {
	case 0:
	case 2:
	mod_perl_error(s, errstr);
	break;

	case 1:
	case 3:
	mod_perl_warn(s, errstr);
	break;

        default:
	mod_perl_error(s, errstr);
	break;
    }

    if(sv) SvREFCNT_dec(sv);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_subprocess_env); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_subprocess_env)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "r, key=NULL, ...");
    {
	Apache	r;
	char *	key;
    I32 gimme = GIMME_V;

	SV *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	if (items < 2)
	    key = NULL;
	else {
	    key = (char *)SvPV_nolen(ST(1))
;
	}
    if(((ix = XSANY.any_i32) == 1) && (gimme == G_ARRAY)) {
	/* backwards compat */
	int i;
	array_header *arr  = perl_cgi_env_init(r);
	table_entry *elts = (table_entry *)arr->elts;
	SP -= items;
	for (i = 0; i < arr->nelts; ++i) {
	    if (!elts[i].key) continue;
	    PUSHelt(elts[i].key, elts[i].val, 0);
	}
	PUTBACK;
	return;
    }
    if((items == 1) && (gimme == G_VOID)) {
        (void)perl_cgi_env_init(r);
        XSRETURN_UNDEF;
    }
    TABLE_GET_SET(r->subprocess_env, FALSE);

	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_request); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_request)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, r=NULL");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
	Apache	r;

	if (items < 2)
	    r = NULL;
	else {
	    r = sv2request_rec(ST(1), "Apache", cv)
;
	}
    self = self;
    if(items > 1) perl_request_rec(r);
    XPUSHs(perl_bless_request_rec(perl_request_rec(NULL)));
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Apache_connection); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_connection)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;
	Apache__Connection	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    RETVAL = r->connection;

	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Apache::Connection", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_server); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_server)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "rsv");
    {
	SV *	rsv = ST(0)
;
    server_rec *s;
    request_rec *r;

	Apache__Server	RETVAL;
    if (SvROK(rsv) && (r = sv2request_rec(rsv, "Apache", cv))) {
	s = r->server;
    }
    else {
	if(!(s = perl_get_startup_server()))
	   croak("Apache->server: no startup server_rec available");
    }

    RETVAL = s;

	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Apache::Server", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_main); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_main)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    if(r->main != NULL)
 	ST(0) = perl_bless_request_rec((request_rec *)r->main);
    else
        ST(0) = &sv_undef;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_prev); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_prev)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    if(r->prev != NULL)
 	ST(0) = perl_bless_request_rec((request_rec *)r->prev);
    else
        ST(0) = &sv_undef;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_next); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_next)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    if(r->next != NULL)
 	ST(0) = perl_bless_request_rec((request_rec *)r->next);
    else
        ST(0) = &sv_undef;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_last); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_last)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;
	Apache	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    for(RETVAL=r; RETVAL->next; RETVAL=RETVAL->next)
        continue;

	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Apache", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_is_initial_req); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_is_initial_req)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;
	int	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	RETVAL = is_initial_req(r);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_is_main); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_is_main)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;
	int	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    if(r->main != NULL) RETVAL = 0;
    else RETVAL = 1;

	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_the_request); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_the_request)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "r, ...");
    {
	Apache	r;
	char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    get_set_PVp(r->the_request,r->pool);

	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_proxyreq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_proxyreq)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "r, ...");
    {
	Apache	r;
	int	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    get_set_IV(r->proxyreq);

	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_header_only); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_header_only)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;
	int	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    RETVAL = r->header_only;

	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_protocol); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_protocol)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;
	char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    RETVAL = r->protocol;

	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_hostname); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_hostname)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "r, ...");
    {
	Apache	r;
	char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    get_set_PVp(r->hostname,r->pool);

	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_status); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_status)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "r, ...");
    {
	Apache	r;
	int	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    get_set_IV(r->status);

	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_allowed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_allowed)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "r, ...");
    {
	Apache	r;
	int	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    get_set_IV(r->allowed);

	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_request_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_request_time)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;
	time_t	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    RETVAL = r->request_time;

	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_status_line); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_status_line)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "r, ...");
    {
	Apache	r;
	char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    get_set_PVp(r->status_line,r->pool);

	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_method); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_method)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "r, ...");
    {
	Apache	r;
	char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    get_set_PVp(r->method,r->pool);

	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_method_number); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_method_number)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "r, ...");
    {
	Apache	r;
	int	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    get_set_IV(r->method_number);

	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_bytes_sent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_bytes_sent)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "r, ...");
    {
	Apache	r;
    request_rec *last;

	long	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    for(last=r; last->next; last=last->next)
        continue;

    if (last->sent_bodyct && !last->bytes_sent) {
	ap_bgetopt(last->connection->client, BO_BYTECT, &last->bytes_sent);
    }

    RETVAL = last->bytes_sent;

    if(items > 1) {
        long nbytes = last->bytes_sent = (long)SvIV(ST(1));
        ap_bsetopt(last->connection->client, BO_BYTECT, &nbytes);
    }

	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_header_in); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_header_in)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "r, key, ...");
    {
	Apache	r;
	char *	key = (char *)SvPV_nolen(ST(1))
;
	SV *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    TABLE_GET_SET(r->headers_in, TRUE);

	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_headers_in); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_headers_in)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Apache	r;
    int i;
    array_header *hdrs_arr;
    table_entry  *hdrs;


	r = sv2request_rec(ST(0), "Apache", cv)
;
    if(GIMME == G_SCALAR) {
	ST(0) = mod_perl_tie_table(r->headers_in); 
	XSRETURN(1); 	
    }
    hdrs_arr = table_elts (r->headers_in);
    hdrs = (table_entry *)hdrs_arr->elts;

    for (i = 0; i < hdrs_arr->nelts; ++i) {
	if (!hdrs[i].key) continue;
	PUSHelt(hdrs[i].key, hdrs[i].val, 0);
    }
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Apache_header_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_header_out)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "r, key, ...");
    {
	Apache	r;
	char *	key = (char *)SvPV_nolen(ST(1))
;
	SV *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    TABLE_GET_SET(r->headers_out, TRUE);

	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_cgi_header_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_cgi_header_out)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "r, key, ...");
    {
	Apache	r;
	char *	key = (char *)SvPV_nolen(ST(1))
;
    char *val;

	SV *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    if((val = (char *)table_get(r->headers_out, key))) 
	RETVAL = newSVpv(val, 0);
    else
        RETVAL = newSV(0);

    SvTAINTED_on(RETVAL);

    if(items > 2) {
	int status = 302;
	val = SvPV(ST(2),na);
        if(!strncasecmp(key, "Content-type", 12)) {
	    r->content_type = pstrdup (r->pool, val);
	}
        else if(!strncasecmp(key, "Status", 6)) {
            sscanf(val, "%d", &r->status);
            r->status_line = pstrdup(r->pool, val);
        }
        else if(!strncasecmp(key, "Location", 8)) {
	    if (val && val[0] == '/' && r->status == 200) {
		/* not sure if this is quite right yet */
		/* set $Apache::DoInternalRedirect++ to test */
		if(DO_INTERNAL_REDIRECT) {
		    r->method = pstrdup(r->pool, "GET");
		    r->method_number = M_GET;

		    table_unset(r->headers_in, "Content-Length");

		    status = 200;
		    perl_soak_script_output(r);
		    internal_redirect_handler(val, r);
		}
	    }
	    table_set (r->headers_out, key, val);
	    r->status = status;
        }   
        else if(!strncasecmp(key, "Content-Length", 14)) {
	    table_set (r->headers_out, key, val);
        }   
        else if(!strncasecmp(key, "Transfer-Encoding", 17)) {
	    table_set (r->headers_out, key, val);
        }   


	else if(!strncasecmp(key, "Set-Cookie", 10)) {
	    table_add(r->err_headers_out, key, val);
	}
        else {
	    table_merge (r->err_headers_out, key, val);
        }
    }
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_headers_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_headers_out)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Apache	r;
    int i;
    array_header *hdrs_arr;
    table_entry  *hdrs;


	r = sv2request_rec(ST(0), "Apache", cv)
;
    if(GIMME == G_SCALAR) {
	ST(0) = mod_perl_tie_table(r->headers_out); 
	XSRETURN(1); 	
    }
    hdrs_arr = table_elts (r->headers_out);
    hdrs = (table_entry *)hdrs_arr->elts;
    for (i = 0; i < hdrs_arr->nelts; ++i) {
	if (!hdrs[i].key) continue;
	PUSHelt(hdrs[i].key, hdrs[i].val, 0);
    }
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Apache_err_header_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_err_header_out)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "r, key, ...");
    {
	Apache	r;
	char *	key = (char *)SvPV_nolen(ST(1))
;
	SV *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    TABLE_GET_SET(r->err_headers_out, TRUE);

	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_err_headers_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_err_headers_out)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "r, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Apache	r;
    int i;
    array_header *hdrs_arr;
    table_entry  *hdrs;


	r = sv2request_rec(ST(0), "Apache", cv)
;
    if(GIMME == G_SCALAR) {
	ST(0) = mod_perl_tie_table(r->err_headers_out); 
	XSRETURN(1); 	
    }
    hdrs_arr = table_elts (r->err_headers_out);
    hdrs = (table_entry *)hdrs_arr->elts;

    for (i = 0; i < hdrs_arr->nelts; ++i) {
	if (!hdrs[i].key) continue;
	PUSHelt(hdrs[i].key, hdrs[i].val, 0);
    }
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Apache_notes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_notes)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "r, key=NULL, ...");
    {
	Apache	r;
	char *	key;
	SV *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	if (items < 2)
	    key = NULL;
	else {
	    key = (char *)SvPV_nolen(ST(1))
;
	}
    TABLE_GET_SET(r->notes, FALSE);

	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_pnotes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_pnotes)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "r, k=Nullsv, val=Nullsv");
    {
	Apache	r;
	SV *	k;
	SV *	val;
    perl_request_config *cfg = NULL;
    char *key = NULL;
    STRLEN len;


	r = sv2request_rec(ST(0), "Apache", cv)
;

	if (items < 2)
	    k = Nullsv;
	else {
	    k = ST(1)
;
	}

	if (items < 3)
	    val = Nullsv;
	else {
	    val = ST(2)
;
	}
    if(k) {
	key = SvPV(k,len);
    }
    cfg = (perl_request_config *)
      get_module_config(r->request_config, &perl_module);
    if (!cfg) {
	XSRETURN_UNDEF;
    }

    if(!cfg->pnotes) cfg->pnotes = newHV();
    if(key) {
	if(hv_exists(cfg->pnotes, key, len)) {
	    ST(0) = SvREFCNT_inc(*hv_fetch(cfg->pnotes, key, len, FALSE));
	    sv_2mortal(ST(0));
	}
	else {
	    ST(0) = &sv_undef;
	}
	if(val) {
	    hv_store(cfg->pnotes, key, len, SvREFCNT_inc(val), FALSE);
	}
    }
    else {
	ST(0) = newRV_inc((SV*)cfg->pnotes);
	sv_2mortal(ST(0));
    }
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_content_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_content_type)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "r, ...");
    {
	Apache	r;
	char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    get_set_PVp(r->content_type,r->pool);

	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_handler); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_handler)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "r, ...");
    {
	Apache	r;
	char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    get_set_PVp(r->handler,r->pool);

	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_content_encoding); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_content_encoding)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "r, ...");
    {
	Apache	r;
	char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    get_set_PVp(r->content_encoding,r->pool);

	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_content_language); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_content_language)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "r, ...");
    {
	Apache	r;
	char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    get_set_PVp(r->content_language,r->pool);

	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_content_languages); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_content_languages)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "r, avrv=Nullsv");
    {
	Apache	r;
	SV *	avrv;
    I32 gimme = GIMME_V;


	r = sv2request_rec(ST(0), "Apache", cv)
;

	if (items < 2)
	    avrv = Nullsv;
	else {
	    avrv = ST(1)
;
	}
    if(avrv && SvROK(avrv))
        r->content_languages = avrv2array_header(avrv, r->pool);

    if(gimme != G_VOID)
        ST(0) = array_header2avrv(r->content_languages);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_no_cache); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_no_cache)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "r, ...");
    {
	Apache	r;
	int	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    get_set_IV(r->no_cache);
    if (r->no_cache) {
	ap_table_setn(r->headers_out, "Pragma", "no-cache");
	ap_table_setn(r->headers_out, "Cache-control", "no-cache");
    }
    else if (items > 1) { /* $r->no_cache(0) */
       ap_table_unset(r->headers_out, "Pragma");
       ap_table_unset(r->headers_out, "Cache-control");
    }

	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_finfo); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_finfo)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "r, sv_statbuf=Nullsv");
    {
	Apache	r;
	SV *	sv_statbuf;
	SV *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	if (items < 2)
	    sv_statbuf = Nullsv;
	else {
	    sv_statbuf = ST(1)
;
	}
    if (sv_statbuf) {
        if (SvROK(sv_statbuf) && SvOBJECT(SvRV(sv_statbuf))) {
            STRLEN sz;
            char *buf = SvPV((SV*)SvRV(sv_statbuf), sz);
            if (sz != sizeof(r->finfo)) {
                croak("statbuf size mismatch, got %d, wanted %d",
                      sz, sizeof(r->finfo));
            }
            memcpy(&r->finfo, buf, sz);
        }
        else {
            croak("statbuf is not an object");
        }
    }
/* workaround for USE_LARGE_FILES on WIN32 ActivePerl 8xx */
#if defined(WIN32) && defined(USE_LARGE_FILES)
    statcache.st_dev = r->finfo.st_dev;
    statcache.st_ino = r->finfo.st_ino;
    statcache.st_mode = r->finfo.st_mode;
    statcache.st_nlink = r->finfo.st_nlink;
    statcache.st_uid = r->finfo.st_uid;
    statcache.st_gid = r->finfo.st_gid;
    statcache.st_rdev = r->finfo.st_rdev;
    statcache.st_size = (__int64) r->finfo.st_size;
    statcache.st_atime = r->finfo.st_atime;
    statcache.st_mtime = r->finfo.st_mtime;
    statcache.st_ctime = r->finfo.st_ctime;
#else
    statcache = r->finfo;
#endif
    if (r->finfo.st_mode) {
	laststatval = 0;
        sv_setpv(statname, r->filename);
    }
    else {
	laststatval = -1;
        sv_setpv(statname, "");
    }
    if(GIMME_V == G_VOID) XSRETURN_UNDEF;
    RETVAL = newRV_noinc((SV*)gv_fetchpv("_", TRUE, SVt_PVIO));

	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_uri); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_uri)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "r, ...");
    {
	Apache	r;
	char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    get_set_PVp(r->uri,r->pool);

	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_filename); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_filename)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "r, ...");
    {
	Apache	r;
	char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    get_set_PVp(r->filename,r->pool);
#ifndef WIN32
    if(items > 1)
	if ((laststatval = stat(r->filename, &r->finfo)) < 0) {
            r->finfo.st_mode = 0;
	}
#endif

	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_path_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_path_info)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "r, ...");
    {
	Apache	r;
	char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    get_set_PVp(r->path_info,r->pool);

	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_query_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_query_string)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "r, ...");
    {
	Apache	r;
	char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    get_set_PVp(r->args,r->pool);

	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    if (ST(0) != &sv_undef) SvTAINTED_on(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_location); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_location)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache	r;
	char *	RETVAL;
	dXSTARG;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    if(r->per_dir_config) {				   
	dPPDIR;
        RETVAL = cld->location;
    }
    else XSRETURN_UNDEF;

	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_dir_config); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_dir_config)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "r, key=NULL, ...");
    {
	Apache	r;
	char *	key;
    perl_dir_config *c;
    perl_server_config *cs;
    server_rec *s;

	SV *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv)
;

	if (items < 2)
	    key = NULL;
	else {
	    key = (char *)SvPV_nolen(ST(1))
;
	}
    ix = ix; /*-Wall*/
    RETVAL = Nullsv;
    if(r && r->per_dir_config) {				   
	c = (perl_dir_config *)get_module_config(r->per_dir_config, 
						 &perl_module);
	TABLE_GET_SET(c->vars, FALSE);
    }
    if (!SvTRUE(RETVAL)) {
	s = r && r->server ? r->server : perl_get_startup_server();
	if (s && s->module_config) {
	    SvREFCNT_dec(RETVAL); /* in case above did newSV(0) */
	    cs = (perl_server_config *)get_module_config(s->module_config, 
							 &perl_module);
	    TABLE_GET_SET(cs->vars, FALSE);
	}
	else XSRETURN_UNDEF;
    }

	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_lookup_uri); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_lookup_uri)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "r, uri");
    {
	Apache	r;
	char *	uri = (char *)SvPV_nolen(ST(1))
;
	Apache__SubRequest	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    RETVAL = sub_req_lookup_uri(uri,r);

	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Apache::SubRequest", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache_lookup_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache_lookup_file)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "r, file");
    {
	Apache	r;
	char *	file = (char *)SvPV_nolen(ST(1))
;
	Apache__SubRequest	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv)
;
    RETVAL = sub_req_lookup_file(file,r);

	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Apache::SubRequest", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache__SubRequest_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__SubRequest_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache__SubRequest	r;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    r = INT2PTR(Apache__SubRequest,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Apache::SubRequest::DESTROY",
			"r")
;
    destroy_sub_req(r);
    MP_TRACE_g(fprintf(stderr, 
	    "Apache::SubRequest::DESTROY(0x%lx)\n", (unsigned long)r));
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Apache__SubRequest_run); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__SubRequest_run)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "r, allow_send_header=0");
    {
	Apache__SubRequest	r;
	int	allow_send_header;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Apache::SubRequest")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    r = INT2PTR(Apache__SubRequest,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Apache::SubRequest::run",
			"r", "Apache::SubRequest")
;

	if (items < 2)
	    allow_send_header = 0;
	else {
	    allow_send_header = (int)SvIV(ST(1))
;
	}
    if (allow_send_header) {
        r->assbackwards = 0;
    }

    RETVAL = run_sub_req(r);

	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Apache); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Apache)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Apache::add_version_component", XS_Apache_add_version_component);
        newXS_deffile("Apache::current_callback", XS_Apache_current_callback);
        newXS_deffile("Apache::sent_header", XS_Apache_sent_header);
        newXS_deffile("Apache::seqno", XS_Apache_seqno);
        newXS_deffile("Apache::perl_hook", XS_Apache_perl_hook);
#if XSubPPtmpAAAA
        newXS_deffile("Apache::get_handlers", XS_Apache_get_handlers);
        newXS_deffile("Apache::set_handlers", XS_Apache_set_handlers);
#endif
        newXS_deffile("Apache::push_handlers", XS_Apache_push_handlers);
        newXS_deffile("Apache::can_stack_handlers", XS_Apache_can_stack_handlers);
        cv = newXS_deffile("Apache::post_connection", XS_Apache_register_cleanup);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Apache::register_cleanup", XS_Apache_register_cleanup);
        XSANY.any_i32 = 0;
        newXS_deffile("Apache::clear_rgy_endav", XS_Apache_clear_rgy_endav);
        newXS_deffile("Apache::stash_rgy_endav", XS_Apache_stash_rgy_endav);
        newXS_deffile("Apache::define", XS_Apache_define);
        newXS_deffile("Apache::module", XS_Apache_module);
        newXS_deffile("Apache::set_opmask", XS_Apache_set_opmask);
        newXS_deffile("Apache::untaint", XS_Apache_untaint);
        newXS_deffile("Apache::taint", XS_Apache_taint);
#if XSubPPtmpAAAB
        newXS_deffile("Apache::child_terminate", XS_Apache_child_terminate);
#endif
        newXS_deffile("Apache::exit", XS_Apache_exit);
        cv = newXS_deffile("Apache::BINMODE", XS_Apache_CLOSE);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Apache::CLOSE", XS_Apache_CLOSE);
        XSANY.any_i32 = 0;
        newXS_deffile("Apache::TIEHANDLE", XS_Apache_TIEHANDLE);
        newXS_deffile("Apache::OPEN", XS_Apache_OPEN);
        newXS_deffile("Apache::FILENO", XS_Apache_FILENO);
        newXS_deffile("Apache::as_string", XS_Apache_as_string);
        newXS_deffile("Apache::chdir_file", XS_Apache_chdir_file);
        newXS_deffile("Apache::gensym", XS_Apache_gensym);
        newXS_deffile("Apache::slurp_filename", XS_Apache_slurp_filename);
        newXS_deffile("Apache::unescape_url", XS_Apache_unescape_url);
        newXS_deffile("Apache::unescape_url_info", XS_Apache_unescape_url_info);
        newXS_deffile("Apache::hard_timeout", XS_Apache_hard_timeout);
        newXS_deffile("Apache::soft_timeout", XS_Apache_soft_timeout);
        newXS_deffile("Apache::kill_timeout", XS_Apache_kill_timeout);
        newXS_deffile("Apache::reset_timeout", XS_Apache_reset_timeout);
        newXS_deffile("Apache::translate_name", XS_Apache_translate_name);
        newXS_deffile("Apache::custom_response", XS_Apache_custom_response);
        newXS_deffile("Apache::satisfies", XS_Apache_satisfies);
        newXS_deffile("Apache::some_auth_required", XS_Apache_some_auth_required);
        newXS_deffile("Apache::requires", XS_Apache_requires);
        newXS_deffile("Apache::allow_options", XS_Apache_allow_options);
        newXS_deffile("Apache::get_server_port", XS_Apache_get_server_port);
        newXS_deffile("Apache::get_server_name", XS_Apache_get_server_name);
        newXS_deffile("Apache::get_remote_host", XS_Apache_get_remote_host);
        newXS_deffile("Apache::get_remote_logname", XS_Apache_get_remote_logname);
        newXS_deffile("Apache::auth_name", XS_Apache_auth_name);
        newXS_deffile("Apache::auth_type", XS_Apache_auth_type);
        newXS_deffile("Apache::document_root", XS_Apache_document_root);
        newXS_deffile("Apache::server_root_relative", XS_Apache_server_root_relative);
        newXS_deffile("Apache::note_basic_auth_failure", XS_Apache_note_basic_auth_failure);
        newXS_deffile("Apache::get_basic_auth_pw", XS_Apache_get_basic_auth_pw);
        newXS_deffile("Apache::user", XS_Apache_user);
        newXS_deffile("Apache::basic_http_header", XS_Apache_basic_http_header);
        newXS_deffile("Apache::send_http_header", XS_Apache_send_http_header);
#if XSubPPtmpAAAC
        newXS_deffile("Apache::send_fd", XS_Apache_send_fd);
#endif
        newXS_deffile("Apache::rflush", XS_Apache_rflush);
        newXS_deffile("Apache::read_client_block", XS_Apache_read_client_block);
        newXS_deffile("Apache::setup_client_block", XS_Apache_setup_client_block);
        newXS_deffile("Apache::should_client_block", XS_Apache_should_client_block);
        newXS_deffile("Apache::get_client_block", XS_Apache_get_client_block);
        cv = newXS_deffile("Apache::WRITE", XS_Apache_write);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Apache::write", XS_Apache_write);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Apache::PRINT", XS_Apache_print);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Apache::print", XS_Apache_print);
        XSANY.any_i32 = 0;
        newXS_deffile("Apache::write_client", XS_Apache_write_client);
        cv = newXS_deffile("Apache::internal_redirect", XS_Apache_internal_redirect_handler);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Apache::internal_redirect_handler", XS_Apache_internal_redirect_handler);
        XSANY.any_i32 = 0;
        newXS_deffile("Apache::log_reason", XS_Apache_log_reason);
        cv = newXS_deffile("Apache::Server::log_error", XS_Apache_log_error);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("Apache::Server::warn", XS_Apache_log_error);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("Apache::log_error", XS_Apache_log_error);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Apache::warn", XS_Apache_log_error);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Apache::cgi_env", XS_Apache_subprocess_env);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Apache::cgi_var", XS_Apache_subprocess_env);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("Apache::subprocess_env", XS_Apache_subprocess_env);
        XSANY.any_i32 = 0;
        newXS_deffile("Apache::request", XS_Apache_request);
        newXS_deffile("Apache::connection", XS_Apache_connection);
        newXS_deffile("Apache::server", XS_Apache_server);
        newXS_deffile("Apache::main", XS_Apache_main);
        newXS_deffile("Apache::prev", XS_Apache_prev);
        newXS_deffile("Apache::next", XS_Apache_next);
        newXS_deffile("Apache::last", XS_Apache_last);
        newXS_deffile("Apache::is_initial_req", XS_Apache_is_initial_req);
        newXS_deffile("Apache::is_main", XS_Apache_is_main);
        newXS_deffile("Apache::the_request", XS_Apache_the_request);
        newXS_deffile("Apache::proxyreq", XS_Apache_proxyreq);
        newXS_deffile("Apache::header_only", XS_Apache_header_only);
        newXS_deffile("Apache::protocol", XS_Apache_protocol);
        newXS_deffile("Apache::hostname", XS_Apache_hostname);
        newXS_deffile("Apache::status", XS_Apache_status);
        newXS_deffile("Apache::allowed", XS_Apache_allowed);
        newXS_deffile("Apache::request_time", XS_Apache_request_time);
        newXS_deffile("Apache::status_line", XS_Apache_status_line);
        newXS_deffile("Apache::method", XS_Apache_method);
        newXS_deffile("Apache::method_number", XS_Apache_method_number);
        newXS_deffile("Apache::bytes_sent", XS_Apache_bytes_sent);
        newXS_deffile("Apache::header_in", XS_Apache_header_in);
        newXS_deffile("Apache::headers_in", XS_Apache_headers_in);
        newXS_deffile("Apache::header_out", XS_Apache_header_out);
        newXS_deffile("Apache::cgi_header_out", XS_Apache_cgi_header_out);
        newXS_deffile("Apache::headers_out", XS_Apache_headers_out);
        newXS_deffile("Apache::err_header_out", XS_Apache_err_header_out);
        newXS_deffile("Apache::err_headers_out", XS_Apache_err_headers_out);
        newXS_deffile("Apache::notes", XS_Apache_notes);
        newXS_deffile("Apache::pnotes", XS_Apache_pnotes);
        newXS_deffile("Apache::content_type", XS_Apache_content_type);
        newXS_deffile("Apache::handler", XS_Apache_handler);
        newXS_deffile("Apache::content_encoding", XS_Apache_content_encoding);
        newXS_deffile("Apache::content_language", XS_Apache_content_language);
        newXS_deffile("Apache::content_languages", XS_Apache_content_languages);
        newXS_deffile("Apache::no_cache", XS_Apache_no_cache);
        newXS_deffile("Apache::finfo", XS_Apache_finfo);
        newXS_deffile("Apache::uri", XS_Apache_uri);
        newXS_deffile("Apache::filename", XS_Apache_filename);
        newXS_deffile("Apache::path_info", XS_Apache_path_info);
        newXS_deffile("Apache::query_string", XS_Apache_query_string);
        newXS_deffile("Apache::location", XS_Apache_location);
        cv = newXS_deffile("Apache::Server::dir_config", XS_Apache_dir_config);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Apache::dir_config", XS_Apache_dir_config);
        XSANY.any_i32 = 0;
        newXS_deffile("Apache::lookup_uri", XS_Apache_lookup_uri);
        newXS_deffile("Apache::lookup_file", XS_Apache_lookup_file);
        newXS_deffile("Apache::SubRequest::DESTROY", XS_Apache__SubRequest_DESTROY);
        newXS_deffile("Apache::SubRequest::run", XS_Apache__SubRequest_run);

    /* Initialisation Section */

    items = items; /*avoid warning*/ 

#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#endif
#if XSubPPtmpAAAC
#endif
    av_push(perl_get_av("Apache::SubRequest::ISA",TRUE), newSVpv("Apache",6));


    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

