/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.28 from the
 * contents of Log.xs. Do not edit this file, edit Log.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#include "mod_perl.h"
#include "mod_perl_xs.h"

#if MODULE_MAGIC_NUMBER >= MMN_132
#define HAVE_LOG_RERROR 1
#else
#define HAVE_LOG_RERROR 0
#endif

static void perl_cv_alias(char *to, char *from)
{
    GV *gp = gv_fetchpv(to, TRUE, SVt_PVCV);
    GvCV_set(gp, perl_get_cv(from, TRUE));
}

static void ApacheLog(int level, SV *sv, SV *msg)
{
 dTHR;
    char *file = NULL;
    int line   = 0;
    char *str;
    SV *svstr = Nullsv;
    int lmask = level & APLOG_LEVELMASK;
    server_rec *s;
    request_rec *r = NULL;

    if(sv_isa(sv, "Apache::Log::Request") && SvROK(sv)) {
	r = (request_rec *) SvIV((SV*)SvRV(sv));
	s = r->server;
    }
    else if(sv_isa(sv, "Apache::Log::Server") && SvROK(sv)) {
	s = (server_rec *) SvIV((SV*)SvRV(sv));
    }
    else {
        croak("Argument is not an Apache or Apache::Server object");
    }

    if((lmask == APLOG_DEBUG) && (s->loglevel >= APLOG_DEBUG)) {
	SV *caller;
	bool old_T = tainting; tainting = FALSE;
	caller = perl_eval_pv("[ (caller)[1,2] ]", TRUE);
	tainting = old_T;
	file = SvPV(*av_fetch((AV *)SvRV(caller), 0, FALSE),na);
	line = (int)SvIV(*av_fetch((AV *)SvRV(caller), 1, FALSE));
    }

    if((s->loglevel >= lmask) && 
       SvROK(msg) && (SvTYPE(SvRV(msg)) == SVt_PVCV)) {
	dSP;
	ENTER;SAVETMPS;
	PUSHMARK(sp);
	(void)perl_call_sv(msg, G_SCALAR);
	SPAGAIN;
	svstr = POPs;
	++SvREFCNT(svstr);
	PUTBACK;
	FREETMPS;LEAVE;
	str = SvPV(svstr,na);
    }
    else
	str = SvPV(msg,na);

    if(r && HAVE_LOG_RERROR) {
#if HAVE_LOG_RERROR > 0
	ap_log_rerror(file, line, APLOG_NOERRNO|level, r, "%s", str);
#endif
    }
    else {
	ap_log_error(file, line, APLOG_NOERRNO|level, s, "%s", str);
    }

    SvREFCNT_dec(msg);
    if(svstr) SvREFCNT_dec(svstr);
}

#define join_stack_msg \
SV *msgstr; \
if(items > 2) { \
    msgstr = newSV(0); \
    do_join(msgstr, &sv_no, MARK+1, SP); \
} \
else { \
    msgstr = ST(1); \
    ++SvREFCNT(msgstr); \
} 

#define MP_AP_LOG(l,s) \
{ \
join_stack_msg; \
ApacheLog(l, s, msgstr); \
}

#define Apache_log_emerg(s) \
MP_AP_LOG(APLOG_EMERG, s)

#define Apache_log_alert(s) \
MP_AP_LOG(APLOG_ALERT, s)

#define Apache_log_crit(s) \
MP_AP_LOG(APLOG_CRIT, s)

#define Apache_log_error(s) \
MP_AP_LOG(APLOG_ERR, s)

#define Apache_log_warn(s) \
MP_AP_LOG(APLOG_WARNING, s)

#define Apache_log_notice(s) \
MP_AP_LOG(APLOG_NOTICE, s)

#define Apache_log_info(s) \
MP_AP_LOG(APLOG_INFO, s)

#define Apache_log_debug(s) \
MP_AP_LOG(APLOG_DEBUG, s)

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif


XS_EUPXS(XS_Apache__Log_log); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Log_log)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
    void *retval;
    char *pclass = "Apache::Log::Request";

    if(!SvROK(sv))
        croak("Argument is not a reference");

    if(sv_derived_from(sv, "Apache")) {
	retval = (void*)sv2request_rec(sv, "Apache", cv);
    }
    else if(sv_derived_from(sv, "Apache::Server")) {
	pclass = "Apache::Log::Server";
	retval = (void *) SvIV((SV*)SvRV(sv));
    }
    else {
        croak("Argument is not an Apache or Apache::Server object");
    }

    ST(0) = sv_newmortal();
    sv_setref_pv(ST(0), pclass, (void*)retval);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache__Log_emerg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Log_emerg)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "s, ...");
    {
	SV *	s = ST(0)
;

	Apache_log_emerg(s);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Apache__Log_alert); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Log_alert)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "s, ...");
    {
	SV *	s = ST(0)
;

	Apache_log_alert(s);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Apache__Log_crit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Log_crit)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "s, ...");
    {
	SV *	s = ST(0)
;

	Apache_log_crit(s);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Apache__Log_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Log_error)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "s, ...");
    {
	SV *	s = ST(0)
;

	Apache_log_error(s);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Apache__Log_warn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Log_warn)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "s, ...");
    {
	SV *	s = ST(0)
;

	Apache_log_warn(s);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Apache__Log_notice); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Log_notice)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "s, ...");
    {
	SV *	s = ST(0)
;

	Apache_log_notice(s);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Apache__Log_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Log_info)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "s, ...");
    {
	SV *	s = ST(0)
;

	Apache_log_info(s);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Apache__Log_debug); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Log_debug)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "s, ...");
    {
	SV *	s = ST(0)
;

	Apache_log_debug(s);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Apache__Server_loglevel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Server_loglevel)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "server, ...");
    {
	Apache__Server	server;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Apache::Server")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    server = INT2PTR(Apache__Server,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Apache::Server::loglevel",
			"server", "Apache::Server")
;
    get_set_IV(server->loglevel); 

	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Apache__Log); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Apache__Log)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Apache::Log::log", XS_Apache__Log_log);
        newXS_deffile("Apache::Log::emerg", XS_Apache__Log_emerg);
        newXS_deffile("Apache::Log::alert", XS_Apache__Log_alert);
        newXS_deffile("Apache::Log::crit", XS_Apache__Log_crit);
        newXS_deffile("Apache::Log::error", XS_Apache__Log_error);
        newXS_deffile("Apache::Log::warn", XS_Apache__Log_warn);
        newXS_deffile("Apache::Log::notice", XS_Apache__Log_notice);
        newXS_deffile("Apache::Log::info", XS_Apache__Log_info);
        newXS_deffile("Apache::Log::debug", XS_Apache__Log_debug);
        newXS_deffile("Apache::Server::loglevel", XS_Apache__Server_loglevel);

    /* Initialisation Section */

    perl_cv_alias("Apache::log", "Apache::Log::log");
    perl_cv_alias("Apache::Server::log", "Apache::Log::log");
    perl_cv_alias("emergency", "emerg");
    perl_cv_alias("critical", "crit");

    av_push(perl_get_av("Apache::Log::Request::ISA",TRUE), 
	    newSVpv("Apache::Log",11));
    av_push(perl_get_av("Apache::Log::Server::ISA",TRUE), 
	    newSVpv("Apache::Log",11));

    items = items; /*avoid warning*/ 

#ifdef newCONSTSUB
 {
    HV *stash = gv_stashpv("Apache::Log", TRUE);
    newCONSTSUB(stash, "EMERG",   newSViv(APLOG_EMERG));
    newCONSTSUB(stash, "ALERT",   newSViv(APLOG_ALERT));
    newCONSTSUB(stash, "CRIT",    newSViv(APLOG_CRIT));
    newCONSTSUB(stash, "ERR",     newSViv(APLOG_ERR));
    newCONSTSUB(stash, "WARNING", newSViv(APLOG_WARNING));
    newCONSTSUB(stash, "NOTICE",  newSViv(APLOG_NOTICE));
    newCONSTSUB(stash, "INFO",    newSViv(APLOG_INFO));
    newCONSTSUB(stash, "DEBUG",   newSViv(APLOG_DEBUG));
 }
#endif


    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

